<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity
{
	const ERROR_NONE				= null;
	const ERROR_USERNAME_INVALID	= 1;
	const ERROR_PASSWORD_INVALID	= 2;
	const ERROR_EMAIL_INVALID		= 3;
	const ERROR_STATUS_NOTACTIV		= 4;
	const ERROR_MAIL_NOTVERIFY		= 5;
	const ERROR_VENDOR_REMOVED		= 6;
	const ERROR_STATUS_BAN			= 7;

	public function authenticate()
	{

		$checkSalt =User::model()->find('user_email=?',array($this->username));
		$userSalt = $checkSalt['user_salt'];
		$checkLogin =User::model()->find('user_email=? AND user_password=?',array($this->username,sha1($this->password.$userSalt)));

		if($checkLogin && $checkLogin->user_type == 1){
			$update = User::model()->UpdateByPk($checkLogin->user_id, array('user_lastlogin'=>date('Y-m-d H:i:s')));
			$admin = Admin::model()->findByPk($checkLogin->user_userid);
			Yii::app()->user->setState('Auser',$admin);
			Yii::app()->user->setState('Auid',$admin->admin_id);
			Yii::app()->user->setState('Display',ucfirst($admin->admin_name));
			Yii::app()->user->setState('Userid',$checkLogin->user_id);
			Yii::app()->user->setState('Token',SHA1(date('Y-m-d H:i:s')));
			Yii::app()->user->setState('UserType',$checkLogin->user_type);
			$this->errorCode=self::ERROR_NONE;

		} else if($checkLogin && $checkLogin->user_type == 3){
			$update = User::model()->UpdateByPk($checkLogin->user_id, array('user_lastlogin'=>date('Y-m-d H:i:s')));
			$agent = Agents::model()->findByPk($checkLogin->user_userid);
			Yii::app()->user->setState('Aguser',$agent);
			Yii::app()->user->setState('Aguid',$agent->pcag_id);
			Yii::app()->user->setState('Display',ucfirst($agent->pcag_store_name));
			Yii::app()->user->setState('Userid',$checkLogin->user_id);
			Yii::app()->user->setState('Token',SHA1(date('Y-m-d H:i:s')));
			Yii::app()->user->setState('UserType',$checkLogin->user_type);
			$this->errorCode=self::ERROR_NONE;
		} else if($checkLogin && $checkLogin->user_type == 4){
			$update = User::model()->UpdateByPk($checkLogin->user_id, array('user_lastlogin'=>date('Y-m-d H:i:s')));
			$regulator = Regulators::model()->findByPk($checkLogin->user_userid);
			Yii::app()->user->setState('Rauser',$regulator);
			Yii::app()->user->setState('Rauid',$regulator->pcrg_id);
			Yii::app()->user->setState('Display',ucfirst($regulator->pcrg_store_name));
			Yii::app()->user->setState('Userid',$checkLogin->user_id);
			Yii::app()->user->setState('Token',SHA1(date('Y-m-d H:i:s')));
			Yii::app()->user->setState('UserType',$checkLogin->user_type);
			$this->errorCode=self::ERROR_NONE;
		} else if($checkLogin && $checkLogin->user_type == 2){
			if($checkLogin->user_activestatus == "1" && $checkLogin->user_status == "1"){
				$update = User::model()->UpdateByPk($checkLogin->user_userid, array('user_lastlogin'=>date('Y-m-d H:i:s')));
				$user = Userdetails::model()->findByPk($checkLogin->user_userid);
				
				Yii::app()->user->setState('User',$user);
				Yii::app()->user->setState('Display',ucfirst($user->pcu_firstname).' '.ucfirst($user->pcu_lastname));
				Yii::app()->user->setState('Userid',$checkLogin->user_userid);
				Yii::app()->user->setState('UserType',$checkLogin->user_type);
				$this->errorCode=self::ERROR_NONE;
			}else{
				$this->errorCode=self::ERROR_USERNAME_INVALID;
			}
		}
		return !$this->errorCode;
	}

}