<?php

/**
 * This is the model class for table "pc_admin".
 *
 * The followings are the available columns in table 'pc_admin':
 * @property integer $admin_id
 * @property string $admin_email
 * @property string $admin_password
 * @property string $admin_opensource
 * @property string $admin_lastlogin
 */
class Admin extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'pc_admin';
	}

	public $admin_email;
	public $admin_password;
	public $admin_new_password;
	public $admin_re_new_password;

	private $_identity;

	public function rules()
	{
		return array(

			array('admin_email,admin_name', 'required' ,'on'=>'update'),
			array('admin_email', 'email','on'=>'update'),
			array('admin_password,admin_email', 'required','on'=>'login'),
			array('admin_password', 'authenticate','on'=>'login'),
			array('admin_password, admin_new_password,admin_re_new_password', 'required','on'=>'PasswordUpdate'),
            array('admin_password, admin_new_password,admin_re_new_password', 'length', 'min'=>6, 'max'=>40,'on'=>'PasswordUpdate'),
            array('admin_new_password', 'compare', 'compareAttribute'=>'admin_re_new_password','on'=>'PasswordUpdate'),
			array('admin_password', 'checkPassword','on'=>'PasswordUpdate'),
			array('admin_id, admin_name, admin_email, admin_status', 'safe', 'on'=>'update,login,PasswordUpdate'),
		);
	}


	public function checkPassword(){
     if(!empty($this->admin_password)){
	    
	     $dataRes =  User::model()->find("user_userid = ? AND user_password =?",array(Yii::app()->user->Auid, MD5($this->admin_password)));
	     if($dataRes && $dataRes->user_type == 1){
	     	return true;
	     } else {
	          $this->addError('admin_password','Please enter valid password code with valid alphanumeric characters');
	     }
	}
	}

	public static function gettablename()
	{
		$Admin = new Admin;
		return $Admin->tableName();
	}

	public static function listData()
	{
		$listData = CHtml::listData(Admin::model()->findAll(array('condition'=>"",'order'=>'')),'primary_column','name_column');
		return $listData;
	}
	

	 public function attributeLabels()
	{
		return array(
			'admin_email' => 'Email',
			'admin_password' => 'Password',
			'admin_new_password' => 'New Password',
			'admin_re_new_password' => 'Confirm Password',
		);
	}

	/**
	 * Authenticates the password.
	 * This is the 'authenticate' validator as declared in rules().
	 */
	public function authenticate($attribute,$params)
	{
		if(!$this->hasErrors())
		{
			$this->_identity=new UserIdentity($this->admin_email,$this->admin_password);
			if(!$this->_identity->authenticate()){
				if($this->_identity->errorCode == UserIdentity::ERROR_MAIL_NOTVERIFY)
					$this->addError('admin_password','Email Id not verified');
				else
					$this->addError('admin_password','Incorrect username or password. ');
			}
		}
	}

	/**
	 * Logs in the user using the given username and password in the model.
	 * @return boolean whether login is successful
	 */
	public function login()
	{
		if($this->_identity===null)
		{
			$this->_identity=new UserIdentity($this->admin_email,$this->admin_password);
			$this->_identity->authenticate();
		}
		if($this->_identity->errorCode===UserIdentity::ERROR_NONE)
		{
			return true;
		}
		else
			return false;
	}

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
