<?php

/**
 * This is the model class for table "pc_settings".
 *
 * The followings are the available columns in table 'pc_settings':
 * @property integer $pcs_id
 * @property string $pcs_site_name
 * @property string $pcs_meta_title
 * @property string $pcs_meta_description
 * @property string $pcs_meta_keywords
 * @property integer $pcs_currency
 * @property integer $pcs_currence_symbol
 * @property string $pcs_gplus
 * @property string $pcs_facebook
 * @property string $pcs_linkden
 * @property string $pcs_publisher_merchant_id_cc
 * @property string $pcs_publisher_merchant_id_usd
 * @property string $pcs_publisher_merchant_id_jmd
 * @property string $pcs_publisher_password
 * @property string $pcs_authorization_type
 * @property string $pcs_plugnpay_test_mode
 * @property string $pcs_plugnpay_test_url
 * @property string $pcs_plugnpay_live_url
 * @property string $pcs_plugnpay_processor_id
 * @property string $pcs_plugnpay_merchant_id
 * @property string $pcs_plugnpay_transaction_password
 * @property string $pcs_personal_per_limit
 * @property string $pcs_busness_per_limit
 */
class Settings extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'pc_settings';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('pcs_site_name, pcs_meta_title, pcs_meta_description, pcs_meta_keywords, pcs_currency, pcs_currence_symbol', 'required'),
			array('pcs_site_name', 'length', 'max'=>32),
			array('pcs_meta_title', 'length', 'max'=>100),
			array('pcs_meta_description, pcs_meta_keywords, pcs_gplus, pcs_facebook, pcs_linkden,pcs_publisher_merchant_id_cc,pcs_publisher_merchant_id_usd,pcs_publisher_merchant_id_jmd,pcs_publisher_password,pcs_authorization_type,pcs_plugnpay_test_mode,pcs_plugnpay_test_url,pcs_plugnpay_live_url,pcs_plugnpay_processor_id,pcs_plugnpay_merchant_id,pcs_plugnpay_transaction_password,pcs_busness_per_limit,pcs_personal_per_limit', 'length', 'max'=>255),
			array('pcs_id, pcs_site_name, pcs_meta_title, pcs_meta_description, pcs_meta_keywords, pcs_currency, pcs_currence_symbol, pcs_gplus, pcs_facebook, pcs_linkden,pcs_publisher_merchant_id_cc,pcs_publisher_merchant_id_usd,pcs_publisher_merchant_id_jmd,pcs_publisher_password,pcs_authorization_type,pcs_plugnpay_test_mode,pcs_plugnpay_test_url,pcs_plugnpay_live_url,pcs_busness_per_limit,pcs_personal_per_limit,pcs_plugnpay_processor_id,pcs_plugnpay_merchant_id,pcs_plugnpay_transaction_password', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'pcs_id' => 'Pcs',
			'pcs_site_name' => 'Site Name',
			'pcs_meta_title' => 'Meta Title',
			'pcs_meta_description' => 'Meta Description',
			'pcs_meta_keywords' => 'Meta Keywords',
			'pcs_busness_per_limit' => 'Limit of Business Account',
			'pcs_personal_per_limit' => 'Limit of Personal Account',
			'pcs_currency' => 'Currency',
			'pcs_currence_symbol' => 'Currence Symbol',
			'pcs_gplus' => 'Gplus URL',
			'pcs_facebook' => 'Facebook URL',
			'pcs_linkden' => 'Linkden URL',
			'pcs_favicon' => 'Favicon',
			'pcs_logo' => 'Logo',
			'pcs_publisher_merchant_id_cc' => 'Merchant ID For CC',
			'pcs_publisher_merchant_id_usd' => 'Merchant ID for USD',
			'pcs_publisher_merchant_id_jmd' => 'Merchant ID for JMD',
			'pcs_publisher_password' => 'Publisher Password',
			'pcs_authorization_type' => 'Authorization Type',
			'pcs_plugnpay_test_mode' => 'Test Mode',
			'pcs_plugnpay_test_url' => 'Test URL',
			'pcs_plugnpay_live_url' => 'Live URL',
			'pcs_plugnpay_processor_id' => 'Processor ID',
			'pcs_plugnpay_merchant_id' => 'Merchant ID',
			'pcs_plugnpay_transaction_password' => 'Transaction Password',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('pcs_id',$this->pcs_id);
		$criteria->compare('pcs_site_name',$this->pcs_site_name,true);
		$criteria->compare('pcs_meta_title',$this->pcs_meta_title,true);
		$criteria->compare('pcs_meta_description',$this->pcs_meta_description,true);
		$criteria->compare('pcs_meta_keywords',$this->pcs_meta_keywords,true);
		$criteria->compare('pcs_currency',$this->pcs_currency);
		$criteria->compare('pcs_currence_symbol',$this->pcs_currence_symbol);
		$criteria->compare('pcs_gplus',$this->pcs_gplus,true);
		$criteria->compare('pcs_facebook',$this->pcs_facebook,true);
		$criteria->compare('pcs_linkden',$this->pcs_linkden,true);
		
		$criteria->compare('pcs_busness_per_limit',$this->pcs_busness_per_limit);
		$criteria->compare('pcs_personal_per_limit',$this->pcs_personal_per_limit);
		$criteria->compare('pcs_publisher_merchant_id_cc',$this->pcs_publisher_merchant_id_cc,true);
		$criteria->compare('pcs_publisher_merchant_id_usd',$this->pcs_publisher_merchant_id_usd,true);
		$criteria->compare('pcs_publisher_merchant_id_jmd',$this->pcs_publisher_merchant_id_jmd,true);
		$criteria->compare('pcs_publisher_password',$this->pcs_publisher_password,true);
		$criteria->compare('pcs_authorization_type',$this->pcs_authorization_type,true);
		$criteria->compare('pcs_plugnpay_test_mode',$this->pcs_plugnpay_test_mode,true);
		$criteria->compare('pcs_plugnpay_test_url',$this->pcs_plugnpay_test_url,true);
		$criteria->compare('pcs_plugnpay_live_url',$this->pcs_plugnpay_live_url,true);
		$criteria->compare('pcs_plugnpay_processor_id',$this->pcs_plugnpay_processor_id,true);
		$criteria->compare('pcs_plugnpay_merchant_id',$this->pcs_plugnpay_merchant_id,true);
		$criteria->compare('pcs_plugnpay_transaction_password',$this->pcs_plugnpay_transaction_password,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Settings the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
